//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2010-2010 - DIGITEO - 
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//



function []=init_arduino(scs_m, needcompile)
    disp("Initialisation Arduino..."); 
    scs=[]
    // On recopie le scs_m
    scs=scs_m;
    // Retrieve all objects
    objs = scs_m.objs;

    nombre_blocs=0;    //Nombre de blocs dans le diagramme
    nombre_liens=0;    //Nombre de lien dans le diagramme
    nb_arduino=0; //nombre de cartes arduino
    port_com_arduino=[];    //numero des ports com associes a chaque carte arduino
//    nb_arduino_digital_write=0; //Nombre de blocs arduino_write dans le diagramme
//    nb_arduino_digital_read=0;  //Nombre de blocs arduino_read dans le diagramme
//    num_arduino_digital_write=[]; //numero des blocs
//    num_arduino_digital_read=[];
//    arduino_pin_digital_write=[];
//    arduino_pin_digital_read=[];
//    nb_arduino_analog_write=0; //Nombre de blocs arduino_write dans le diagramme
//    nb_arduino_analog_read=0;  //Nombre de blocs arduino_read dans le diagramme
//    num_arduino_analog_write=[]; //numero des blocs
//    num_arduino_analog_read=[];
//    arduino_pin_analog_write=[];
//    arduino_pin_analog_read=[];
    
    list_arduino_gui=["ARDUINO_DIGITAL_WRITE","ARDUINO_DIGITAL_READ","ARDUINO_ANALOG_WRITE","ARDUINO_ANALOG_READ","ARDUINO_DCMOTOR","ARDUINO_SERVO_WRITE","ARDUINO_SERVO_READ","ARDUINO_STEPPER","ARDUINO_ENCODER"];
    nb_block_by_type=[]
    arduino_pin_by_typeblock=cell(size(list_arduino_gui,2),1)
    for i=1:size(list_arduino_gui,2)
        nb_block_by_type($+1)=0;
        arduino_pin_by_typeblock(i).entries=[];
    end    

    //Récupère le nombre de blocs dans le modèle
    for i=1:size(objs)

        if typeof(objs(i))=='Block' then
            nombre_blocs=nombre_blocs+1;
        end
    end

    // Passe en revue tous les blocs pour relever dans des tableaux chacun des types de blocs
    for i=1:nombre_blocs
        if objs(i).gui=="ARDUINO_SETUP" then nb_arduino=nb_arduino+1;
            disp("num arduino"+string(objs(i).model.rpar(2)))
            port_com_arduino(nb_arduino)=objs(i).model.rpar(2);
        end
        rep=find(objs(i).gui==list_arduino_gui);
        if ~isempty(rep) then
           nb_block_by_type(rep)=nb_block_by_type(rep)+1;
           arduino_pin_by_typeblock(rep).entries($+1)=objs(i).model.rpar(1); 
        end
        

        // Si bloc digital_write, incrémente le compteur de ce bloc, stock son numéro de bloc et son pin
//        if objs(i).gui=="ARDUINO_DIGITAL_WRITE" then nb_arduino_digital_write=nb_arduino_digital_write+1;
//            num_arduino_digital_write(nb_arduino_digital_write)=i;
//            arduino_pin_digital_write(nb_arduino_digital_write)=objs(i).model.rpar(1); //releve de la valeur de pin
//        end
//        if objs(i).gui=="ARDUINO_ANALOG_WRITE" then nb_arduino_analog_write=nb_arduino_analog_write+1;
//            num_arduino_analog_write(nb_arduino_analog_write)=i;
//            arduino_pin_analog_write(nb_arduino_analog_write)=objs(i).model.rpar(1); //releve de la valeur de pin
//        end
//        if objs(i).gui=="ARDUINO_DIGITAL_READ" then nb_arduino_digital_read=nb_arduino_digital_read+1;
//            num_arduino_digital_read(nb_arduino_digital_read)=i;
//            arduino_pin_digital_read(nb_arduino_digital_read)=objs(i).model.rpar(1); //releve de la valeur de pin
//        end
//        if objs(i).gui=="ARDUINO_ANALOG_READ" then nb_arduino_analog_read=nb_arduino_analog_read+1;
//            num_arduino_analog_read(nb_arduino_analog_read)=i;
//            arduino_pin_analog_read(nb_arduino_analog_read)=objs(i).model.rpar(1); //releve de la valeur de pin
//        end  
//        if objs(i).gui=="ARDUINO_SERVO_READ" then nb_arduino_servo_read=nb_arduino_servo_read+1;
//            num_arduino_servo_read(nb_arduino_servo_read)=i;
//            arduino_pin_servo_read(nb_arduino_servo_read)=objs(i).model.rpar(1); //releve de la valeur de pin
//        end
//        if objs(i).gui=="ARDUINO_SERVO_WRITE" then nb_arduino_servo_write=nb_arduino_servo_write+1;
//            num_arduino_servo_write(nb_arduino_servo_write)=i;
//            arduino_pin_servo_write(nb_arduino_servo_write)=objs(i).model.rpar(1); //releve de la valeur de pin
//        end      
//        if objs(i).gui=="ARDUINO_DCMOTOR" then nb_arduino_dcmotor=nb_arduino_dcmotor+1;
//            num_arduino_dcmotor(nb_arduino_dcmotor)=i;
//            arduino_pin_dcmotor(nb_arduino_dcmotor)=objs(i).model.rpar(1); //releve de la valeur de pin
//        end      
//        if objs(i).gui=="ARDUINO_STEPPER" then nb_arduino_stepper=nb_arduino_stepper+1;
//            num_arduino_stepper(nb_arduino_stepper)=i;
//            arduino_pin_stepper(nb_arduino_stepper)=objs(i).model.rpar(1); //releve de la valeur de pin
//        end
//        if objs(i).gui=="ARDUINO_ENCODER" then nb_arduino_encoder=nb_arduino_encoder+1;
//            num_arduino_encoder(nb_arduino_encoder)=i;
//            arduino_pin_encoder(nb_arduino_encoder)=objs(i).model.rpar(1); //releve de la valeur de pin
//        end            
//        if objs(i).gui=="ARDUINO_SETUP" then nb_arduino=nb_arduino+1;
//            disp("num arduino"+string(objs(i).model.rpar(2)))
//            port_com_arduino(nb_arduino)=objs(i).model.rpar(2);
//        end
end

    //initialisation des ports_com
    //TODO : ouvrir plusieurs ports_com
    global port_com
    try
        port_com=openserial(port_com_arduino(1),"115200,n,8,1");
        disp("com ok")
        sleep(2000)
    catch
        messagebox("Mauvais port de communication.")
        error('Mauvais port de communication.')
    end
    //configuration des Pin Pout
    try
       //mise a zero programme arduino
       writeserial(port_com,ascii(201)+ascii(201));
       
       for j=1:size(list_arduino_gui,2)
           disp(list_arduino_gui(j))
           for i=arduino_pin_by_typeblock(j).entries
               
               if list_arduino_gui(j)=="ARDUINO_DIGITAL_WRITE" then
                  pin="0"+ascii(97+i)+"1";  // élaboration du string à envoyer pour initialiser le pin
                  writeserial(port_com,pin);  // envoyer le string                  
               end
               if list_arduino_gui(j)=="ARDUINO_DIGITAL_READ" then
                  pin="0"+ascii(97+i)+"0";
                  writeserial(port_com,pin);                    
               end
               if list_arduino_gui(j)=="ARDUINO_ANALOG_WRITE" then
                  pin="0"+ascii(97+i)+"1";
                  writeserial(port_com,pin);                         
               end           
               if list_arduino_gui(j)=="ARDUINO_ANALOG_READ" then
                   if i~=0 & i~=1 then
                      pin="0"+ascii(97+i)+"0";
                      writeserial(port_com,pin);  
                      //astuce pour éviter probleme port 0 et 1 
                      //pin="3"+ascii(97+i);
                      //writeserial(port_com,pin);
                      //value=readserial(port_com);                        
                   end
               end             
               if list_arduino_gui(j)=="ARDUINO_DCMOTOR" then
                   disp("motor")
                   code_sent="92";
                   writeserial(port_com,code_sent);  
               end             
               if list_arduino_gui(j)=="ARDUINO_STEPPER" then
                   
               end             
               if list_arduino_gui(j)=="ARDUINO_SERVO_WRITE" then
                   if i==1 then //servo 1 on pin 10
                       pin="6a1" 
                       writeserial(port_com,pin); 
                       //writeserial(port_com,"8a"+ascii(0)) //positionnement en 0
                   elseif i==2 then //servo 2 on pin 9
                       pin="6b1" 
                       writeserial(port_com,pin); 
                       //writeserial(port_com,"8b"+ascii(0)) //positionnement en 0
                   else
                       messagebox("Probleme dans le numero du servomoteur")
                        error('problem')
                   end
                   disp(pin)
               end             
               if list_arduino_gui(j)=="ARDUINO_SERVO_READ" then
                   if i==1 then //servo 1 on pin 10
                       pin="6a1" 
                       writeserial(port_com,pin); 
                   elseif i==2 then //servo 2 on pin 9
                       pin="6b1" 
                       writeserial(port_com,pin); 
                   else
                       messagebox("Probleme dans le numero du servomoteur")
                        error('problem')
                   end
                   disp(pin)
               end             
               if list_arduino_gui(j)=="ARDUINO_ENCODER" then
                   code_sent="E"+string(i)+"a" 
                   disp(code_sent)
                   writeserial(port_com,code_sent); 
                   
               end   
          end          
       end
       
//       for i=arduino_pin_digital_write
//          pin="0"+ascii(97+i)+"1";  // élaboration du string à envoyer pour initialiser le pin
//          disp(pin)
//          writeserial(port_com,pin);  // envoyer le string    
//          //sleep(500)
//       end  
//       for i=arduino_pin_digital_read
//          pin="0"+ascii(97+i)+"0";
//          disp(pin)
//          writeserial(port_com,pin);      
//          //sleep(500)
//       end  
//       for i=arduino_pin_analog_write
//          pin="0"+ascii(97+i)+"1";
//          disp(pin)
//          writeserial(port_com,pin);      
//          //sleep(500)
//       end  
//       for i=arduino_pin_analog_read
//          pin="0"+ascii(97+i)+"0";
//          disp(pin)
//          writeserial(port_com,pin);   
//          pin="3"+ascii(97+i);
//          writeserial(port_com,pin);
//          value=readserial(port_com); 
//          disp(ascii(value))
//       end  

    catch
        error('Mauvais port de communication.')
    end

    disp("Initialisation terminee")
    
endfunction




















