//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2010-2010 - DIGITEO -
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//

function scs_m=REP_TEMP_pre_simulate(scs_m)

    nombre_blocs=0;    //Nombre de blocs dans le diagramme
    for i=1:size( scs_m.objs)
        if typeof( scs_m.objs(i))=='Block' then
            nombre_blocs=nombre_blocs+1;
            if scs_m.objs(i).gui=="REP_TEMP" then
                num_pts=scs_m.objs(i).model.rpar(1);
                tf=scs_m.objs(i).model.rpar(2);
                grid_on=evstr(scs_m.objs(i).graphics.exprs(2));
            end
        end
    end
    
    num_scope=[];
    nb_outputs=[];
    nb_total_outputs=0;
    nb_scope=0;
    legendes=cell();
//    grid_on=0;
    for i=1:nombre_blocs
        obj=scs_m.objs(i);
        if typeof( obj )=='Block' then
            if obj.gui=="SCOPE" then 
                nb_scope=nb_scope+1;
                num_scope(nb_scope)=i;
                nb_outputs(nb_scope)=evstr(scs_m.objs(i).graphics.exprs(1));
                for no=1:nb_outputs(nb_scope)
                    scs_m.objs(i).model.rpar.objs(5*(no-1)+2).graphics.exprs=[string(num_pts);"o"+string(no+nb_total_outputs);"0"];
                    scs_m.objs(i).model.rpar.objs(5*(no-1)+2).model.ipar=[num_pts;2;24;no+nb_total_outputs];
                    scs_m.objs(i).model.rpar.objs(5*(no-1)+3).graphics.exprs=[string(tf/num_pts);"0"];
                    scs_m.objs(i).model.rpar.objs(5*(no-1)+3).model.rpar=[tf/num_pts;0];
                end
                legendes(nb_scope).entries=scs_m.objs(i).graphics.exprs(2:$);
                nb_total_outputs=nb_total_outputs+nb_outputs(nb_scope);
            elseif obj.gui=="CSCOPE"  then
                scs_m.objs(i).model.rpar(4) = tf;
            elseif obj.gui=="CMSCOPE"  then
                scs_m.objs(i).model.rpar(2) = tf;
            end
            
        end
    end

    scs_m.props.tf=tf;

endfunction

//
//function [continueSimulation,scs_m]=REP_TEMP_pre_simulate(scs_m, needcompile)
//
//    scs=[]
//
//    // On recopie le scs_m
//    scs=scs_m;
//
//
//    nombre_blocs=0;    //Nombre de blocs dans le diagramme
//    for i=1:size( scs_m.objs)
//        if typeof( scs_m.objs(i))=='Block' then
//            nombre_blocs=nombre_blocs+1;
//            if scs_m.objs(i).gui=="REP_TEMP" then
//                num_pts=scs_m.objs(i).model.rpar(1);
//                tf=scs_m.objs(i).model.rpar(2);
//                grid_on=evstr(scs_m.objs(i).graphics.exprs(2));
//            end
//        end
//    end
//    
//    num_scope=[];
//    nb_outputs=[];
//    nb_total_outputs=0;
//    nb_scope=0;
//    legendes=cell();
////    grid_on=0;
//    for i=1:nombre_blocs
//        obj=scs.objs(i);
//        if typeof( obj )=='Block' then
//            if obj.gui=="SCOPE" then 
//                nb_scope=nb_scope+1;
//                num_scope(nb_scope)=i;
//                nb_outputs(nb_scope)=evstr(scs.objs(i).graphics.exprs(1));
//                for no=1:nb_outputs(nb_scope)
//                    scs.objs(i).model.rpar.objs(5*(no-1)+2).graphics.exprs=[string(num_pts);"o"+string(no+nb_total_outputs);"0"];
//                    scs.objs(i).model.rpar.objs(5*(no-1)+2).model.ipar=[num_pts;2;24;no+nb_total_outputs];
//                    scs.objs(i).model.rpar.objs(5*(no-1)+3).graphics.exprs=[string(tf/num_pts);"0"];
//                    scs.objs(i).model.rpar.objs(5*(no-1)+3).model.rpar=[tf/num_pts;0];
//                end
//                legendes(nb_scope).entries=scs.objs(i).graphics.exprs(2:$);
//                nb_total_outputs=nb_total_outputs+nb_outputs(nb_scope);
//
//            elseif obj.gui=="AUTO_SCOPE" then
//                scs.objs(i).graphics.exprs=[string(num_pts);string(tf);""];
//                scs.objs(i).model.rpar.objs(3).graphics.exprs(1)=string(tf/num_pts);
//                scs.objs(i).model.rpar.objs(3).model.rpar=[tf/num_pts ; 0] ;
//                scs.objs(i).model.rpar.objs(2).graphics.exprs(7)=string(tf);
//                scs.objs(i).model.rpar.objs(2).model.rpar(4) = tf ; 
//                scs.objs(i).model.rpar.objs(4).graphics.exprs=string(tf);
//                scs.objs(i).model.rpar.objs(4).model.firing = tf;
//                
//            elseif  obj.gui=="AUTO_SCOPE2" then
//
//                scs.objs(i).graphics.exprs=[string(num_pts);string(tf);""];
//                scs.objs(i).model.rpar.objs(1).graphics.exprs(1)=string(tf/num_pts);
//                scs.objs(i).model.rpar.objs(1).model.rpar=[tf/num_pts ; 0];
//                tf_vec=tf*ones(2,1);
//                scs.objs(i).model.rpar.objs(2).graphics.exprs(8)=strcat(string(tf_vec),' ');
//                scs.objs(i).model.rpar.objs(2).model.rpar(2) = tf ;
//                scs.objs(i).model.rpar.objs(2).model.rpar(3) = tf ;
//                scs.objs(i).model.rpar.objs(3).graphics.exprs=string(tf);
//                scs.objs(i).model.rpar.objs(3).model.firing = tf;
// 
//            elseif obj.gui=="AUTO_SCOPE3" then 
//                
//            elseif obj.gui=="CSCOPE"  then
//                scs.objs(i).model.rpar(4) = tf;
//            elseif obj.gui=="CMSCOPE"  then
//                scs.objs(i).model.rpar(2) = tf;
//            end
//            
//        end
//    end
//
//    scs.props.tf=tf;
//    scs_m=scs;
////    
////    
////    scicos_simulate(scs);
////    disp('termine')
////    
////    c_color=[[0.75,0.75,0];[0.25,0.25,0.25];[0,0,1];[0,0.5,0];[1,0,0];[0,0.75,0.75];[0.75,0,0.75]];
////    
////    handle_fig=figure();
////
////    drawlater();
////    //extraction des champs stockés
////    D=[];
////    legend_c=[];
////
////    for i=1:nb_scope
////        subplot(nb_scope,1,i);
////        //legend_c=strsplit(scs.objs(num_scope(i)).graphics.exprs(2)," ");
////        legend_c=legendes(i).entries;
////        if size(legend_c,1)~=nb_outputs(i) then
////            legend_c="courbe"+string([1:nb_outputs(i)]);
////        end
////        for no=1:nb_outputs(i)
////            label=scs.objs(num_scope(i)).model.rpar.objs(5*(no-1)+2).graphics.exprs(2);
////            D(i,no)=evstr(label);
////            //legend_c(no)=label;
////           
////            
////            plot(D(i,no).time,D(i,no).values,'color',[c_color(modulo(no,6)+1,1),c_color(modulo(no,6)+1,2),c_color(modulo(no,6)+1,3)],'thickness',2)
////        end
////        legend(legend_c);
////        set(handle_fig,"background",8)
////
////        if grid_on==1 then
////            xgrid;
////        end
////        //title("scope_"+string(i));
////    end
////    drawnow();
//////    for i=1:nb_outputs(1)
//////      plot(D(1,1).time,D(1,i).values,'color',[c_color(modulo(i,6)+1,1),c_color(modulo(i,6)+1,2),c_color(modulo(i,6)+1,3)],'thickness',2)
//////    end
//////    D(1,1)=evstr("A"+string(1))
//////                scf(handle_fig)
//////                plot(o1.time,D(1,1).values,'color',[c_color(modulo(1,6)+1,1),c_color(modulo(1,6)+1,2),c_color(modulo(1,6)+1,3)],'thickness',2)
//////                set(handle_fig,"background",8)
//////                xgrid
////    
////
////nicescope();
////
////    // Force Simulation to start after pre_simulation process.
//    continueSimulation = %t
//endfunction
//
//

